require "imgui"

local Working = false
local freezeNumber = 0
local miniTimer = 0
local thread -- Our thread object.
local receiveLine = love.thread.getChannel( "sendLine" )
local threadAction = love.thread.getChannel( "action" )


function love.load()
    thread = love.thread.newThread( "threadRead.lua" )
end


function love.update(dt)
    imgui.NewFrame()
    
    -- Make sure no errors occured.
    local error = thread:getError()
    assert( not error, error )

    if Working then
        local threadIsDone = threadAction:pop() or not thread:isRunning()
        if threadIsDone then Working = false end
        local received = receiveLine:pop()
        if received then
            print(received)
        end
    end

    miniTimer = miniTimer + 1
    if miniTimer == 20 then
        freezeNumber = freezeNumber + 1
        freezeNumber = freezeNumber % 100
    end
    miniTimer = miniTimer % 30
end

function love.draw()
  --drawing stuff
  if imgui.Button("Read files") then
    if Working == false then
      Working = true
      thread:start()
    end
  end
  
  imgui.Render()
  love.graphics.print(freezeNumber)
  --drawing stuff
end

function love.textinput(t)
    imgui.TextInput(t)
end

function love.keypressed(key)
    imgui.KeyPressed(key)
end

function love.keyreleased(key)
    imgui.KeyReleased(key)
end

function love.mousemoved(x, y)
    imgui.MouseMoved(x, y)
end

function love.mousepressed(x, y, button)
    imgui.MousePressed(button)
end

function love.mousereleased(x, y, button)
    imgui.MouseReleased(button)
end

function love.wheelmoved(x, y)
    imgui.WheelMoved(y)
end

